<?php
/************************************************
 *
 *              dbfMySQL
 *
 *  originally written by: Miguel Feitosa 
 *   for Vamonessa Venture Partners
 *
 *  updated by: Leonard den Ottolander (2002,2003)
 *
 *  Package to assist porting 
 *   dbf files to MySQL tables
 *  For this modification you need the PHP
 *   patch that provides the functions
 *    - dbase_field_names
 *    - dbase_field_types
 *    - dbase_field_lengths
 *    - dbase_field_decimals
 *    also by Leonard den Ottolander (2002)
 *
 *  This version of the software is GPL.
 *  The original package is in the public domain.
 *  Use at your own risk.
 *   
 *  old contact: mfeitosa@vamonessa.com.br
 *           http://www.vamonessa.com.br
 *  contact: leonardjo@hetnet.nl
 *
 *************************************************/
// *********************************************************************************
// *
// * Este  o mdulo common, tem funes para validar nmeros e dar sada etc.
// * visite http://www.vamonessa.com.br
// *
// *  Written by Vamonessa members. 
// *  For info: contact: vamonessa@vamonessa.com.br
// *  August, 2000 1.0
// * 
// * 
// *  For usage, see below functions. 
// * 
// * 
// * 
// *
// *
// *
// *
// *
// ***********************************************************************************

if(isset($_vmn_func)) return;
$_vmn_func=TRUE;

//* ************** valid_float ******************************************************/
/* this function returns an associative array with 
the following structure:
key "in" => "$in" No changes to input
key "eua" => Number formatted in american syntax, no $t (thousands)
key "form" => Number formatted in syntax proposed
key "error" => true if number could not be parsed, only "in" is set.
key "clean" => no syntax, just the numbers with $p digit precision
*/

function valid_float( $in , $t="." , $d=",",$p="2"  ) {

 $pat_v = "[^0123456789$t$d]";
 $dirty_valor = eregi( $pat_v, $in );

 if($dirty_valor) {
   $retVal["error"] = TRUE;
   $retVal["in"] = $in;
   return $retVal;
 }

 $got_t  =    strrpos($valor_c, $t);
 $got_d  =    strrpos($valor_c, $d);

 if( $got_t!=FALSE && $got_d!=FALSE && $got_t > $got_d ) {
   $retVal["error"] = TRUE;
   $retVal["in"] = $in;
   return $retVal;
 }

 $valor_c = str_replace($t, "m", $in );
 $valor_c = str_replace($d, ".", $valor_c );
 $valor_c = str_replace("m", ",", $valor_c );

 $temp = "";

 for($j=0; $j<strlen($valor_c); $j++) {
   if($valor_c[$j] != "," ) $temp.=$valor_c[$j];
 }

 $retVal["in"] = $in;
 $retVal["error"] = FALSE;
 $retVal["eua"] = $temp;
 $temp = number_format($temp,$p, $d ,$t);
 $retVal["form"] = $temp;

 $pat_v = "[^0123456789]";
 $dirty_valor = eregi( $pat_v,$temp );

 for($j=0; $j<strlen($temp); $j++) {
   if(eregi($pat_v,$temp[j])==FALSE ) $aux.=$temp[$j];
 }

 $retVal["clean"] = $aux;

 return $retVal;
} 

//* **************  valid_int   ******************************************************/

/* this function returns an associative array with 
the following structure:
key "in" => "$in" No changes to input
key "clip" => Number clipped to fit size.
key "pad" => Number padded to fit size.
key "form" => Number not padded/clipped
key "error" => true if number had anything other than digits
key "len" => true if strlen(int)>l$len
*/

function valid_int($in , $len=100 ) {
  $pat_i = "[^0123456789]";
  $dirty_valor = eregi( $pat_i, $in );

  $retVal["in"] = $in;

 if($dirty_valor) {
   $retVal["error"] = TRUE;
    return $retVal;
 }

 if(strlen($in)> $len) {
   for($j=strlen($in)-$len ; $j<strlen($in); $j++) {
     $aux.=$in[$j];
   }
   $retVal["len"] = TRUE;
   $retVal["clip"] = $aux;
 }else {$retVal["clip"] = $in;}

 if(strlen($in) < $len) {
   $aux = "";
   for($j= 1 ; $j<= $len - strlen($in); $j++) {
     $aux.="0";
   }
   $aux = $aux.$in;
   $retVal["pad"] = $aux;
 }else {$retVal["pad"] = $in;}

 $retVal["form"] = $in;

 return $retVal;  

}

//* **************  valid_date   ******************************************************/

/* This functions parses dates in dd/mm/yyyy or YYYY-MM-dd format.
This function returns an associative array with 
the following structure:
key "dd" => dd 
key "mm" => mm
key "yyyy" => yyyy
key "error" => true if input could not be parsed.
key "in" => $in;
*/

function valid_date( $in , $mold=FALSE ) {
if(!$mold){
  

  $type = "dd/mm/yyyy";
  $retVal["in"] = $in;

  if(strlen($in) != strlen($type) ) {
    $retVal["error"] = TRUE;
    return $retVal;
  } 

  $temp = explode("/", $in);
  $dd = $temp[0]; 
  $mm = $temp[1];
  $yyyy =$temp[2]; 

}else{
  $type = "yyyy-mm-dd";
  $retVal["in"] = $in;

  if(strlen($in) != strlen($type) ) {
    $retVal["error"] = TRUE;
    return $retVal;
  } 

  $temp = explode("-", $in);
  $dd = $temp[2]; 
  $mm = $temp[1];
  $yyyy =$temp[0]; 

}

 $pat_v = "[^0123456789]";
 
 if( eregi( $pat_v, $dd )!=FALSE || eregi( $pat_v, $mm )!=FALSE ||  eregi( $pat_v, $yyyy )!=FALSE) {
   $retVal["error"] = TRUE;
   return $retVal;
 }
 
 if($dd>31 || $dd<1 || $mm > 12 || $mm<1 || $yyyy < 1900) { 
   $retVal["error"] = TRUE;
   return $retVal;
 } 

 
/*
$monthArray = array(31,29,31,30,31,30,31,31,30,31,30,31); 
 
$maxdays = $monthArray[$mm-1]; 
 
if( $mm == 2) { 
 
	if(floor($yyyy/4) != (float)($yyyy/4)) { 
		$maxdays = 29; 
	} else { 
		$maxdays = 28; 
	} 
} 
*/

 $retVal["dd"] = $dd;
 $retVal["mm"] = $mm;
 $retVal["yyyy"] = $yyyy;
 
if( checkdate($mm, $dd, $yyyy)==FALSE ) { 
   $retVal["error"] = TRUE;
   return $retVal; 
} 
 
return $retVal; 
 
}

function isEmail($email) { 
 $domain = strstr ($email, '@');

if ($domain==FALSE) return FALSE; 

return TRUE; 

}
//* ************** cmpdate   ******************************************************/
// returns >0 $before < $after
// return 0  $before == $after
// return <0 $before > $after 
// dates are in "mysql" format Y-m-d
//

function cmpdate($before, $after) {
  $before = explode("-",$before);
  $after =  explode("-", $after);
  $before = mktime(0, 0, 0, $before[1], $before[2], $before[0]);
  $after = mktime(0, 0, 0, $after[1], $after[2], $after[0]);
 return ($after-$before);
} 

//* ************** br_date   ******************************************************/

/* This functions transforms a yyyymmdd date into dd/mm/yyyy or YYYY-MM-dd format.
This function returns an associative array with 
the following structure:
key "dd" => dd 
key "mm" => mm
key "yyyy" => yyyy
key "error" => true if input could not be parsed.
key "in" => $in;
key "mysql" => YYYY-MM-dd
key "br" => dd/mm/yyyy
*/

function br_date( $in) {
  $retVal["in"] = $in;
  $type = "yyyymmdd";
/* 
 if(strlen($in) != strlen($type) ) {
    $retVal["error"] = TRUE;
    return $retVal;
  } 
*/
  $dd = $in[6].$in[7]; 
  $mm = $in[4].$in[5];
  $yyyy =$in[0].$in[1].$in[2].$in[3]; 


 $pat_v = "[^0123456789]";
 
 if( eregi( $pat_v, $dd )!=FALSE || eregi( $pat_v, $mm )!=FALSE ||  eregi( $pat_v, $yyyy )!=FALSE) {
   $retVal["error"] = TRUE;
   return $retVal;
 }
 
 if($dd>31 || $dd<1 || $mm > 12 || $mm<1 || $yyyy < 1900) { 
   $retVal["error"] = TRUE;
   return $retVal;
 } 

 $retVal["dd"] = $dd;
 $retVal["mm"] = $mm;
 $retVal["yyyy"] = $yyyy;
 
if( checkdate($mm, $dd, $yyyy)==FALSE ) { 
   $retVal["error"] = TRUE;
   return $retVal; 
} 

 $retVal["mysql"] = "$yyyy-$mm-$dd";
 $retVal["br"] = "$dd/$mm/$yyyy";

return $retVal; 
 
}

//* **************  isWhite   ******************************************************/
 
function isWhite($x) { 
$x = trim($x);
if(strlen($x)<1) return TRUE;

return FALSE; 
} 

///**********************isOOO()****/
function isOOO($in) {
for($i=0;$i<strlen($in);$i++){
if($in[$i]!="0") return FALSE;
}
return TRUE;
}

function modsum($x) {
$retVal=0;

$x = strval($x);
if(!is_string($x) && !is_array($x)) return $x;

for( $i=0 ; $i < strlen($x); $i++) {
$retVal +=  $x[$i];
}
return $retVal;
}


//* **************  padquote   ******************************************************/

function padquote( $in ) {

  return "\"".$in. "\"";

}


//* **************  echo_val   ******************************************************/
/*
This function is usefull for restoring cookie values 
*/

function echo_val($in,$old="") {
 global $COOK;
 $temp=$in.$COOK;
 global $$in;
 global $$temp;

 if(isset($$in)) {
   echo( "value =\"${$in}\" " );
 }else if(isset($$temp)) {
   echo( "value =\"${$temp}\" " );
   $$in = $$temp;
 }else{
   echo( "value =\"".$old."\" " );
 }

}

//* **************  echo_txt   ******************************************************/

function echo_txt($in,$old="") {
 global $COOK;
 $temp=$in.$COOK;
 global $$in;
 global $$temp;

 if(isset($$in)) {
   echo( ${$in} );
 }else if(isset($$temp)) {
   echo( ${$temp} );
   $$in = $$temp;
 }else{
   echo( $old );
 }

}

//* **************  echo_sel   ******************************************************/

function echo_sel($in,$target="0",$param="selected") {
 global $COOK;
 $temp=$in.$COOK;
 global $$in;
 global $$temp;
 

 global $MODE; 
 global $DISPLAY;        
 global $COOKIE;
     
if(isset($$in)) {
   if($$in == $target){
     echo($param);
   }
 }else if(isset($$temp) && $MODE==$COOKIE) {
   if($$temp == $target) {
     echo( $param );
   }
  $$in = $$temp;
 }

}

//* **************  dump_array   ******************************************************/


function dump_array($arr) {
if(!is_array($arr)) { echo($arr); return; }
  reset($arr);
  global $DEBUG;

  while (list ($key, $val) = each ($arr)) {
    
    if(is_array($val)) dump_array($val);
    
    if($DEBUG) { echo("$key=>$val"."<BR> \n"); } 
    else { echo("$val"."<BR> \n");}

    }

}


//* **************  concat_array   ******************************************************/


function concat_array($arr) {
if(!is_array($arr)) {  return $arr; }
  reset($arr);
  global $DEBUG;

  while (list ($key, $val) = each ($arr)) {
    
    if(is_array($val)){$retVal .= concat_array($val);}
    
    if($DEBUG) { $retVal .= "$key=>$val"."<BR>"; } 
    else { $retVal .= "$val"."<BR>";}

    }
return $retVal;
}

?>
