<?php
/************************************************
 *
 *              dbfMySQL
 *
 *  originally written by: Miguel Feitosa 
 *   for Vamonessa Venture Partners
 *
 *  updated by: Leonard den Ottolander (2002,2003)
 *
 *  Package to assist porting 
 *   dbf files to MySQL tables
 *  For this modification you need the PHP
 *   patch that provides the functions
 *    - dbase_field_names
 *    - dbase_field_types
 *    - dbase_field_lengths
 *    - dbase_field_decimals
 *    also by Leonard den Ottolander (2002)
 *
 *  This version of the software is GPL.
 *  The original package is in the public domain.
 *  Use at your own risk.
 *   
 *  old contact: mfeitosa@vamonessa.com.br
 *           http://www.vamonessa.com.br
 *  contact: leonardjo@hetnet.nl
 *
 *************************************************/
include("var.php3");

if(!isset($file_name)) {
?>

<html>
<?php print($css); ?>
<body>
<form method="GET" action="<?php echo "$URL/show.php3" ?>" >
Inform the full path name of a DBF file:
<input type="text" name="file_name" >
<input type="submit" value="Open" name="Open" >
</form>
</body>
</html>
<?php
exit();
}
?>

<?php
set_time_limit (0);

$h = dbase_open($file_name, 0);

if($h==FALSE) { 
  print "$file_name cannot be open for reading";
  exit();
} else {
  $num = dbase_numrecords ($h);

  if(!isset($ini)) $ini=1;
  if(!isset($fini)) $fini = $PASSO;

  print "Current Table: $file_name. <BR> Rows: $ini,$fini<BR> Rows: $num";

  for( $i=$ini ; $i<=$num && $i<=$fini ; $i++ ) {
  $records[] =  dbase_get_record_with_names ($h, $i);
  }  
  $names = dbase_field_names ($h);
  $types = dbase_field_types ($h);
  $lengths = dbase_field_lengths ($h);
  $decimals = dbase_field_decimals ($h);
  
  if(sizeof($records)<=0) {
    print "No rows selected or retrieved" ;
    exit();
  }

  $ini = $fini;
  $fini = $fini+$PASSO;
  $temp = urlencode($file_name);
  $url = "?file_name=$temp&ini=$ini&fini=$fini";
  $temp = urlencode(dirname ($file_name));
  $voltar = "$URL/index.php3?dbf_dir=$temp";
  $url = "$URL/show.php3".$url;
  
  ?>
  <html>
  <?php print($css); ?>
  <body>
  
  <BR><a href="<?php print $voltar ?>" > Return to DBF Table List </a> 
 <form  method="GET" action="<?php print "$URL/show.php3" ?>" >
  <input type="hidden" name="file_name" value="<?php print $file_name ?>">
     Show from row: 
  <input type="text" value="<?php print $ini ; ?>"  name="ini" size="5" >
   to row:  <input type="text" value="<?php print $fini ; ?>"  name="fini" size="5" >
  <input type="submit" value="Show" >
   </form>
    
<!--  <a href="<?php print $url ?>" > Show next <?php print $PASSO; ?>  rows </a> <BR> -->
 
  <form method="GET" action="<?php echo "$URL/schema.php3" ?>" >
  <input type="hidden" name="file_name" value="<?php print $file_name ?>">

<?php
  $tbl_name = $file_name;
  $last_dot = strrpos ($tbl_name, ".");
  if (is_string ($last_dot) && !$last_dot)
  {
         // not found...
  }
  else
  {
    $tbl_name = substr($tbl_name, 0 , $last_dot);
  }
  $last_slash = strrpos($file_name,"/");            
  if (is_string ($last_slash) && !$last_slash)
  {
         // not found...
  }
  else
  {
    $tbl_name = substr($tbl_name, $last_slash+1);
  }
?>

  Destination table name: <input type="text" value="<?php print $tbl_name ?>" name="table_name" >
  <input type="submit" value="Create Table Schema" >
  
  <table> 
  <tr> <th> Field Name </th> <th> Data Type </th> <th> Index </th> <th> Data </th> </tr> 
  <?php
  
  $i = 0;
  
  $fieldnames = array_keys($records[0]);
  
  while (list ($nada, $fieldname) = each ($fieldnames)) {
    echo("<tr>\n");
/*    $tempo = "did[index_".$fieldname."($fieldname)]"; */
    $destnames = "did[".$fieldname."]";
/*    echo("<td> <input type=\"checkbox\" value=\"Y\"  name=\"$tempo\" > </td>\n "); */
/*    echo("     <td> <input type=\"text\" value=\"$fieldname\"  name=\"$fieldname"."_d_id\" > </td>\n "); */
    echo("     <td> <input type=\"text\" value=\"$fieldname\"  name=\"$destnames\" > </td>\n ");
    
    $tam = $lengths[$i];
    
    $tam = "varchar($tam)";

    switch ($types[$i])
    { case "C":
	$tam = "CHAR($lengths[$i])";
        break;
      case "D":
        $tam = "DATE";
        break;
      case "N":
        if ($decimals[$i] == 0)
	{ $tam = "INTEGER";
	}
	else
	{ $l = $lengths[$i] - 1;
	  $tam = "DECIMAL($l,$decimals[$i])";
	};
	break;
      default:
        $tam = "UNKNOWN TYPE";
        break;
    }
    echo("     <td> <input type=\"text\" value=\"$tam\"  name=\"$fieldname\" > </td>\n ");


    $tempo = "mig[index_".$fieldname."($fieldname)]";
    $tempo = "mig[".$fieldname."]";
    echo("<td> <input type=\"checkbox\" value=\"Y\"  name=\"$tempo\" > </td>\n ");

    
    reset($records);
    while (list ($recordnumber, $record) = each ($records)) {
      echo("    <td> $record[$fieldname]</td>\n");  
    } 

    $i++;
    
    echo("</tr>"); 
   
  } 


  dbase_close($h);  
  print "</table>";
  print "</form>";
}
 
?>
</body></html>
